#include "transforms.inc"

#include "nsss.inc"

#ifndef(Upper_ax) #local Upper_ax=0; #end

#ifdef(Upper_dx) #local Upper_ax=Upper_ax + Upper_dx; #end

#local Upper_ax=min(max(Upper_ax,-30),0);



#ifndef(Upper_ay) #local Upper_ay=0; #end

#ifdef(Upper_dy) #local Upper_ay=Upper_ay + Upper_dy; #end

#local Upper_ay=min(max(Upper_ay,0),0);



#ifndef(Upper_az) #local Upper_az=0; #end

#ifdef(Upper_dz) #local Upper_az=Upper_az + Upper_dz; #end

#local Upper_az=min(max(Upper_az,0),0);



#ifndef(Upper_sl) #local Upper_sl=0.75; #end

#ifdef(Upper_dl) #local Upper_sl=Upper_sl + Upper_dl; #end

#local Upper_sl=min(max(Upper_sl,0.75),0.75);



#ifndef(Upper_p)

#local Upper_p=<0.005,-0.495894,-0.500179>;

#end

#ifdef(Upper_dp) #local Upper_p=Upper_p + Upper_dp; #end



#ifndef(Lower_ax) #local Lower_ax=0; #end

#ifdef(Lower_dx) #local Lower_ax=Lower_ax + Lower_dx; #end

#local Lower_ax=min(max(Lower_ax,0),30);



#ifndef(Lower_ay) #local Lower_ay=0; #end

#ifdef(Lower_dy) #local Lower_ay=Lower_ay + Lower_dy; #end

#local Lower_ay=min(max(Lower_ay,0),0);



#ifndef(Lower_az) #local Lower_az=0; #end

#ifdef(Lower_dz) #local Lower_az=Lower_az + Lower_dz; #end

#local Lower_az=min(max(Lower_az,0),0);



#ifndef(Lower_sl) #local Lower_sl=0.75; #end

#ifdef(Lower_dl) #local Lower_sl=Lower_sl + Lower_dl; #end

#local Lower_sl=min(max(Lower_sl,0.75),0.75);



#ifndef(Lower_p)

#local Lower_p=<0.005,-0.495894,-0.500179>;

#end

#ifdef(Lower_dp) #local Lower_p=Lower_p + Lower_dp; #end



#declare Upper_tb=transform { rotate <Upper_ax,Upper_ay,0> translate Upper_p }
#declare Upper_te=transform { rotate z*Upper_az translate z*Upper_sl transform Upper_tb }
#declare Lower_tb=transform { rotate <Lower_ax,Lower_ay,0> translate Lower_p }
#declare Lower_te=transform { rotate z*Lower_az translate z*Lower_sl transform Lower_tb }
#local pV0=<0.5,1,0>;

#local pV1=<1,1,0>;

#local pV2=<1,0.5,0>;

#local pV3=<0.5,0.5,0>;

#local pV4=<0,0.5,0.1>;

#local pV5=<0,1,0>;

#local pV6=<-0.5,1,0>;

#local pV7=<-0.5,0.5,0>;

#local pV8=<-1,0.5,0>;

#local pV9=<-1,1,0>;

#local pVa=<1,0,0>;

#local pVb=<0.5,0,0>;

#local pVc=<0,0,0.1>;

#local pVd=<-0.5,0,0>;

#local pVe=<-1,0,0>;

#local pVf=<0.5,-0.5,0>;

#local pV10=<1,-0.5,0>;

#local pV11=vtransform(<0,0,-0.2>,Upper_te);

#local pV12=<-0.5,-0.5,0>;

#local pV13=<-1,-0.5,0>;

#local pV14=<1,-1,0>;

#local pV15=<0.5,-1,0>;

#local pV16=<-0.5,-1,0>;

#local pV17=<-1,-1,0>;

#local pV18=vtransform(<0,0,-0.2>,Lower_te);

#local pV19=<0,-1,0>;



#local apV=array[26] {

pV0,pV1,pV2,pV3,pV4,pV5,pV6,pV7,pV8,pV9,pVa,pVb,pVc,pVd,pVe,pVf,

pV10,pV11,pV12,pV13,pV14,pV15,pV16,pV17,pV18,pV19

}



#local aiF=array[16][4] {

{ 3,2,1,0},

{ 3,0,5,4},

{ 5,4,7,6},

{ 7,6,9,8},

{ 2,3,11,10},

{ 4,3,11,12},

{ 4,7,13,12},

{ 8,7,13,14},

{ 11,10,16,15},

{ 11,12,17,15},

{ 13,12,17,18},

{ 13,14,19,18},

{ 16,15,21,20},

{ 19,18,22,23},

{ 25,22,18,24},

{ 25,21,15,24}

}



SSS_ImportBasicMesh(apV,aiF)



#local aiM=array[16][4] {

{ <0.75,0.75>,<1,0.75>,<1,1><0.75,1> },

{ <0.75,0.75>,<0.75,1>,<0.5,1><0.5,0.75> },

{ <0.5,1>,<0.5,0.75>,<0.25,0.75><0.25,1> },

{ <0.25,0.75>,<0.25,1>,<0,1><0,0.75> },

{ <1,0.75>,<0.75,0.75>,<0.75,0.5><1,0.5> },

{ <0.5,0.75>,<0.75,0.75>,<0.75,0.5><0.5,0.5> },

{ <0.5,0.75>,<0.25,0.75>,<0.25,0.5><0.5,0.5> },

{ <0,0.75>,<0.25,0.75>,<0.25,0.5><0,0.5> },

{ <0.75,0.5>,<1,0.5>,<1,0.25><0.699,0.289> },

{ <0.75,0.5>,<0.5,0.5>,<0.5,0.288><0.699,0.289> },

{ <0.25,0.5>,<0.5,0.5>,<0.5,0.288><0.254,0.287> },

{ <0.25,0.5>,<0,0.5>,<0,0.25><0.254,0.287> },

{ <1,0.25>,<0.699,0.289>,<0.75,0><1,0> },

{ <0,0.25>,<0.254,0.287>,<0.25,0><0,0> },

{ <0.5,0>,<0.25,0>,<0.254,0.287><0.5,0.288> },

{ <0.5,0>,<0.75,0>,<0.699,0.289><0.5,0.288> }

}



SSS_AddUVMapping(aiM)



#local aiT=array[16] {

0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

}



SSS_AddTextures(aiT)



// texture 0 is named Texture1 in the model.

