#include "data.h"
extern HWND hwndMain;
extern HWND hwndStatusBar;

//extern RECT windRect,statRect;

extern PPROJECT ActiveProject;

SCROLLINFO hsi={
	sizeof(SCROLLINFO),
	SIF_DISABLENOSCROLL|SIF_PAGE|SIF_POS|SIF_RANGE,
	0,0,0,0,0
};

SCROLLINFO vsi={
	sizeof(SCROLLINFO),
	SIF_DISABLENOSCROLL|SIF_PAGE|SIF_POS|SIF_RANGE,
	0,0,0,0,0
};

SCROLLINFO gsi={
	sizeof(SCROLLINFO),
	SIF_DISABLENOSCROLL|SIF_PAGE|SIF_POS|SIF_RANGE,
	0,0,0,0,0
};

void SetScroll(void) {
//	MYPTR m;
	view *view;
//	VECTOR qu;
//	int pX,pY;


	if(ActiveProject==NULL) {
		EnableScrollBar(hwndMain,SB_BOTH,ESB_DISABLE_BOTH);
		return;
	}

	view=&(ActiveProject->cView);
	view->Extent.left=view->Extent.top=0;
	view->Extent.right=view->sX;
	view->Extent.bottom=view->sY;

	switch(ActiveProject->EditMode) {
		case EM_MESHEDIT:
//			MapVertices();
//			STEPVERTS(ActiveProject,m.v) {
//				if(m.v->pY < view->Extent.top) view->Extent.top=m.v->pY;
//				if(m.v->pX < view->Extent.left) view->Extent.left=m.v->pX;
//				if(m.v->pX > view->Extent.right) view->Extent.right=m.v->pX;
//				if(m.v->pY > view->Extent.bottom) view->Extent.bottom=m.v->pY;
//			}
//			MapKnobs();
//			STEPKNOBS(ActiveProject,m.k) {
//				if(m.k->pY < view->Extent.top) view->Extent.top=m.k->pY;
//				if(m.k->pX < view->Extent.left) view->Extent.left=m.k->pX;
//				if(m.k->pX > view->Extent.right) view->Extent.right=m.k->pX;
//				if(m.k->pY > view->Extent.bottom) view->Extent.bottom=m.k->pY;
//			}
		break;
		case EM_MAPEDIT:
//			MapUVPts();
//			STEPUVPTS(ActiveProject,m.u) {
//				if(m.u->pY < view->Extent.top) view->Extent.top=m.u->pY;
//				if(m.u->pX < view->Extent.left) view->Extent.left=m.u->pX;
//				if(m.u->pX > view->Extent.right) view->Extent.right=m.u->pX;
//				if(m.u->pY > view->Extent.bottom) view->Extent.bottom=m.u->pY;
//			}
		break;
	}

	EnableScrollBar(hwndMain,SB_BOTH,ESB_ENABLE_BOTH);

//	hsi.cbSize=sizeof(SCROLLINFO);
//	hsi.fMask=SIF_DISABLENOSCROLL|SIF_PAGE|SIF_POS|SIF_RANGE;
	hsi.nMin=view->Extent.left;
	hsi.nMax=view->Extent.right-1;
	hsi.nPage=view->sX+1; // allowed range from 0 to nMax-nMin+1
	hsi.nPos=0;  // allowed range from nMin to nMax-MAX(0,nPage-1);
	hsi.nTrackPos=0;
	SetScrollInfo(hwndMain,SB_HORZ,&hsi,TRUE);

//	vsi.cbSize=sizeof(SCROLLINFO);
//	vsi.fMask=SIF_DISABLENOSCROLL|SIF_PAGE|SIF_POS|SIF_RANGE;
	vsi.nMin=view->Extent.top;
	vsi.nMax=view->Extent.bottom-1;
	vsi.nPage=view->sY+1; // allowed range from 0 to nMax-nMin+1
	vsi.nPos=0;  // allowed range from nMin to nMax-MAX(0,nPage-1);
	vsi.nTrackPos=0;
	SetScrollInfo(hwndMain,SB_VERT,&vsi,TRUE);
}

void HScroll(WPARAM wParam) {
	vec xyzs,xyzf;
	short pX;

	if(ActiveProject==NULL) return;

	GetScrollInfo(hwndMain,SB_HORZ,&hsi);

	mapScr2XYZ(&ActiveProject->cView,0,0,xyzs);

	switch(LOWORD(wParam)) {
		case SB_PAGERIGHT:	pX= hsi.nPage; break;
		case SB_PAGELEFT:	pX=-(int)hsi.nPage; break;
		case SB_LINERIGHT:	pX= hsi.nPage>>3; break;
		case SB_LINELEFT:	pX=-(int)(hsi.nPage>>3); break;
//		case SB_THUMBPOSITION: scr[X]=hsi.nTrackPos-hsi.nPos; break;
	}

	mapScr2XYZ(&ActiveProject->cView,pX,0,xyzf);

	ActiveProject->cView.Orient[LX]+=xyzf[X]-xyzs[X];
	ActiveProject->cView.Orient[LY]+=xyzf[Y]-xyzs[Y];
	ActiveProject->cView.Orient[LZ]+=xyzf[Z]-xyzs[Z];

	InvalidateView();
}

void VScroll(WPARAM wParam) {
	vec xyzs,xyzf;
	short pY;

	if(ActiveProject==NULL) return;

	GetScrollInfo(hwndMain,SB_VERT,&vsi);

	mapScr2XYZ(&ActiveProject->cView,0,0,xyzs);

	switch(LOWORD(wParam)) {
		case SB_PAGEDOWN:	pY= hsi.nPage; break;
		case SB_PAGEUP:		pY=-(int)hsi.nPage; break;
		case SB_LINEDOWN:	pY= hsi.nPage>>3; break;
		case SB_LINEUP:		pY=-(int)(hsi.nPage>>3); break;
//		case SB_THUMBPOSITION: scr[X]=hsi.nTrackPos-hsi.nPos; break;
	}

	mapScr2XYZ(&ActiveProject->cView,0,pY,xyzf);

	ActiveProject->cView.Orient[LX]+=xyzf[X]-xyzs[X];
	ActiveProject->cView.Orient[LY]+=xyzf[Y]-xyzs[Y];
	ActiveProject->cView.Orient[LZ]+=xyzf[Z]-xyzs[Z];

	InvalidateView();
}


